#include <iostream>
#include <vector>
#include <queue>
#include <fstream>

using namespace std;

struct next_stop{
    int num;
    int time_here;
    int time_there;
    int cost;

    next_stop(int n, int th, int tt, int c){
        num = n;
        time_here = th;
        time_there = tt;
        cost = c;
    }
};

const int inf = 1000007;

vector <next_stop> stop[256];
int cnt_stop, cnt_way, t0, start, finish, pure_cost;
vector <int> timer, days, cost,prevs;
vector <vector <int> > time_leave;

int fulltime(int n){
    return days[n]*1440+timer[n];
}

void print_new(int a, int b){
    cout << a << " -> " << b << " new values : " <<
        days[b] << " " << timer[b] << " " << cost[b] << endl;
}

void proof_of_fast(){
    int cur = prevs[finish], next_time = inf, cnt = 0, del = inf;
    int leave_time = time_leave[cur][finish];
    int pre = prevs[cur];
    next_stop* nt = new next_stop(0,0,0,0);
    next_stop next = *nt;
    while(cur != start){
        del = inf;
        cnt = 0;
        for(int i = 0; i < stop[pre].size(); i++){
            next = stop[pre][i];
            if(next.num == cur && next.time_there < time_leave[pre][cur]){
                cnt++;
                del = min(del,next.cost);
            }
        }
        if(cnt == 0){
           for(int i = 0; i < stop[pre].size(); i++){
            next = stop[pre][i];
            if(next.num == cur){
                cnt++;
                del = min(del,next.cost);
            }
            }
        }
        cost[cur] = del;
 //       cout << cost[cur] << endl;
        cur = prevs[cur];
        pre = prevs[cur];
    }
    cur = prevs[finish];
    int sum = 0;
    while(cur!=start){
        sum += cost[cur];
        cur = prevs[cur];
    }
    sum += pure_cost;
  //  cout <<"Sum is : " << sum << endl;
    cost[finish] = sum;
}

pair <int,int> dej_fast(int st, int fin){
    queue <int> Q;
    int cur = st;
    Q.push(st);
    timer[st] = t0;
    cost[st] = 0;
    days[st] = 0;
    next_stop* nt = new next_stop(0,0,0,0);
    next_stop next = *nt;
    while(!Q.empty()){
        cur = Q.front();
        Q.pop();
        for(int i = 0; i < stop[cur].size(); i++){
            next = stop[cur][i];
            if(timer[cur] <= next.time_here){
                if(fulltime(next.num) > days[cur]*1440 + next.time_there){
                    cost[next.num] = cost[cur] + next.cost;
                    timer[next.num] = next.time_there;
                    days[next.num] = days[cur];
                    prevs[next.num] = cur;
                    time_leave[cur][next.num] = next.time_here;
                    if(next.num == finish) pure_cost = next.cost;
                    Q.push(next.num);
                }
                else if(fulltime(next.num) == days[cur]*1440 + next.time_there
                        && cost[cur] + next.cost < cost[next.num]){
                        cost[next.num] = cost[cur] + next.cost;
                        timer[next.num] = next.time_there;
                        days[next.num] = days[cur];
                        prevs[next.num] = cur;
                        time_leave[cur][next.num] = next.time_here;
                        if(next.num == finish) pure_cost = next.cost;
                        Q.push(next.num);
                }
            }
            else{
                if(fulltime(next.num) > (days[cur]+1)*1440 + next.time_there){
                    cost[next.num] = cost[cur] + next.cost;
                    timer[next.num] = next.time_there;
                    days[next.num] = days[cur]+1;
                    prevs[next.num] = cur;
                    time_leave[cur][next.num] = next.time_here;
                    if(next.num == finish) pure_cost = next.cost;
                    Q.push(next.num);
                }
                else if(fulltime(next.num) == (days[cur]+1)*1440 + next.time_there
                        && cost[cur] + next.cost < cost[next.num]){
                        cost[next.num] = cost[cur] + next.cost;
                        timer[next.num] = next.time_there;
                        days[next.num] = days[cur]+1;
                        prevs[next.num] = cur;
                        time_leave[cur][next.num] = next.time_here;
                        if(next.num == finish) pure_cost = next.cost;
                        Q.push(next.num);
                }
            }
        }
    }
//    proof_of_fast();
    return make_pair(days[fin]*1440+timer[fin],cost[fin]);
}

pair <int,int> dej_cheap(int st, int fin){
    queue <int> Q;
    int cur = st;
    Q.push(st);
    timer[st] = t0;
    days[st] = 0;
    cost[st] = 0;
    next_stop* nt = new next_stop(0,0,0,0);
    next_stop next = *nt;
    while(!Q.empty()){
        cur = Q.front();
        Q.pop();
        for(int i = 0; i < stop[cur].size(); i++){
            next = stop[cur][i];
            if(cost[next.num] > cost[cur] + next.cost){
                cost[next.num] = cost[cur] + next.cost;
                timer[next.num] = next.time_there;
                days[next.num] = days[cur];
                if(timer[cur] > next.time_here)
                    days[next.num]++;
                Q.push(next.num);
            }
            else if(cost[next.num] == cost[cur] + next.cost){
                if(timer[cur] <= next.time_here
                   && days[cur]*1440 + next.time_there < days[next.num] * 1440 + timer[next.num]){
                    days[next.num] = days[cur];
                    timer[next.num] = next.time_there;
                    Q.push(next.num);
                }
                else if(timer[cur] > next.time_here
                   && (days[cur]+1)*1440 + next.time_there < days[next.num] * 1440 + timer[next.num]){
                    days[next.num] = days[cur]+1;
                    timer[next.num] = next.time_there;
                    Q.push(next.num);
                }
            }
        }
    }
    return make_pair(days[fin]*1440+timer[fin],cost[fin]);
}

int main(){
    freopen("tax.in","r",stdin);
    freopen("tax.out","w", stdout);
    int a, b, c, prev_a, prev_b, prev_c;
    cin >> cnt_stop >> cnt_way >> t0 >> start >> finish;
    while(cin >> a >> b >> c){
        if(c != 0){
            next_stop* nt = new next_stop(a,prev_b,b,c);
            stop[prev_a].push_back(*nt);
        }
        prev_a = a;
        prev_b = b;
        prev_c = c;
    }
    pair <int,int> best;
    timer.resize(cnt_stop+1,inf);
    time_leave.resize(cnt_stop+1, vector<int> (cnt_stop+1));
    days.resize(cnt_stop+1,inf);
    cost.resize(cnt_stop+1,inf);
    prevs.resize(cnt_stop+1,start);
    best = dej_fast(start,finish);
    cout <<best.first << " " << best.second << endl;
    timer.assign(cnt_stop+1,inf);
    days.assign(cnt_stop+1,inf);
    cost.assign(cnt_stop+1,inf);
    best = dej_cheap(start,finish);
    cout <<best.first << " " << best.second << endl;

    return 0;
}
